load "HumbertEquations.m";

Q<[x]>:=PolynomialRing(Rationals(),6 : Global:=true);
P<[p]>:=PolynomialRing(Rationals(),3);
S<[s]>:=PolynomialRing(P,6);

function PolynomialFromPowerSums(p1,p2,p3,p4,p5,p6)
	e0:=1;
	e1:=p1;
	e2:=1/2*(e1*p1-p2);
	e3:=1/3*(e2*p1-e1*p2+p3);
	e4:=1/4*(e3*p1-e2*p2+e1*p3-p4);
	e5:=1/5*(e4*p1-e3*p2+e2*p3-e1*p4+p5);
	e6:=1/6*(e5*p1-e4*p2+e3*p3-e2*p4+e1*p5-p6);
	Q<t>:=PolynomialRing(Rationals());
	return t^6-e1*t^5+e2*t^4-e3*t^3+e4*t^2-e5*t+e6;
end function;




function pullbacksymmetricpt(s1,s2,s3,s4,s5,s6)
	QBar:=AlgebraicClosure(Rationals());
	SatakePolynomial:=PolynomialFromPowerSums(s1,s2,s3,s4,s5,s6);
	R<s>:=PolynomialRing(QBar);
	rts:=Roots(R!SatakePolynomial);
	r1:=rts[1][1];	
	r2:=rts[2][1];
	r3:=rts[3][1];
	r4:=rts[4][1];
	r5:=rts[5][1];
	r6:=rts[6][1];
	return [r1,r2,r3,r4,r5,r6];
end function;


HumbertEquations:=[];
HumbertEquations[24]:=f24;
HumbertEquations[25]:=f25;
HumbertEquations[28]:=f28;
HumbertEquations[29]:=f29;
HumbertEquations[32]:=f32;
HumbertEquations[33]:=f33;
HumbertEquations[36]:=f36;
HumbertEquations[37]:=f37;
HumbertEquations[40]:=f40;
HumbertEquations[44]:=f44;
HumbertEquations[48]:=f48;



function testHumbertSurface(d,s1,s2,s3,s4,s5,s6)
  if(d mod 8 eq 0) then 
	I:=[2,3];
  end if;
  if(d mod 8 eq 4) then 
	I:=[3,5];
  end if;
  if(d mod 8 eq 1) then 
	I:=[1,2,5];
  end if;
  if(d mod 8 eq 5) then 
	I:=[1];
  end if;

  fp:=Evaluate(HumbertEquations[d],[s1,s2,s3,s4,s5,s6]);
  print "test1";
  pbs:=pullbacksymmetricpt(s1,s2,s3,s4,s5,s6);
  print "test2";
  allpbs:=[pbs[[1..6]^x] : x in Sym(6)]; // here are all 720 preimages.
  print "test3";
  xx:=allpbs[1];
  print "test4";
  field:=Universe(xx);
  print "test5";

  print fp;



  Counter:=0;
  for xx in allpbs do
  print "test6";
  Counter:=Counter+1;
  print Counter;
    pp:=[field| &+[x^k : x in xx[I]] : k in [1..3]];
    if ( Evaluate(fp,pp) eq 0 ) then
	return true;
    end if;
  end for;
  return false;
end function;
